org.springframework.http

## Enum HttpMethod

- java.lang.Object
- - java.lang.Enum<HttpMethod>
  - - org.springframework.http.HttpMethod

- All Implemented Interfaces:
    Serializable, Comparable<HttpMethod>

      public enum HttpMethod
      extends Enum<HttpMethod>

  Enumeration of HTTP request methods. Intended for use with `ClientHttpRequest` and `RestTemplate`.
  Since:
    3.0
  Author:
    Arjen Poutsma, Juergen Hoeller

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `DELETE`
    `GET`
    `HEAD`
    `OPTIONS`
    `PATCH`
    `POST`
    `PUT`
    `TRACE`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `matches(String method)` Determine whether this `HttpMethod` matches the given method value.
    `static HttpMethod` | `resolve(String method)` Resolve the given method value to an `HttpMethod`.
    `static HttpMethod` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static HttpMethod[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### GET

          public static final HttpMethod GET

    - #### HEAD

          public static final HttpMethod HEAD

    - #### POST

          public static final HttpMethod POST

    - #### PUT

          public static final HttpMethod PUT

    - #### PATCH

          public static final HttpMethod PATCH

    - #### DELETE

          public static final HttpMethod DELETE

    - #### OPTIONS

          public static final HttpMethod OPTIONS

    - #### TRACE

          public static final HttpMethod TRACE

  - ### Method Detail

    - #### values

          public static HttpMethod[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (HttpMethod c : HttpMethod.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static HttpMethod valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### resolve

          @Nullable
          public static HttpMethod resolve(@Nullable
                                                     String method)

      Resolve the given method value to an `HttpMethod`.
      Parameters:
        `method` - the method value as a String
      Returns:
        the corresponding `HttpMethod`, or `null` if not found
      Since:
        4.2.4

    - #### matches

          public boolean matches(String method)

      Determine whether this `HttpMethod` matches the given method value.
      Parameters:
        `method` - the HTTP method as a String
      Returns:
        `true` if it matches, `false` otherwise
      Since:
        4.2.4